/*
gcc -Wall -Werror MM-CPU.c  -o MM-CPU.out
./MM-CPU.out
Time spent: 10.769143
*/

#include <stdio.h>
#include <sys/time.h>
#include <stdlib.h>

#define Width 512

void verify(float *P, int size){
int i,j;
float sum;
for(i=0;i<size;i++)
	for(j=0;j<size;j++)
		sum += P[i*size+j];
printf("Verification Sum: %f\n",sum);
}

int main(void){

  int size = Width * Width * sizeof(float);
  float *M, *N, *P;
  int x,y,i,j,k;

  // Allocate the matrices M,N,P
  M = (float*)malloc(size);
  N = (float*)malloc(size);
  P = (float*)malloc(size);

  // fill in the matrices with data
  for (y=0; y<Width; y++) {
    for (x=0; x<Width; x++){
      M[y*Width + x] = x + y*Width;
      N[y*Width + x] = x + y*Width; 
    }
  }

  // capture the start time
  struct timeval timer_start, timer_end;
  gettimeofday(&timer_start, NULL);

  // Matrix Multiplication Computation
  for (i = 0; i < Width; i++){
    for (j = 0; j < Width; j++){
      float sum = 0;
      for (k = 0; k < Width; k++){
        sum += M[i * Width + k] * N[k * Width + j];
      }
      P[i * Width + j] = sum;
    }
  }
   
gettimeofday(&timer_end, NULL);   
double timer_spent = timer_end.tv_sec - timer_start.tv_sec +
         (timer_end.tv_usec - timer_start.tv_usec) / 1000000.0;
printf("Time spent: %.6f\n", timer_spent);

  verify(P, Width);
  // free memory allocated to matrices M,N,P
  free( M );
  free( N );
  free( P );

  return 0;
}
